use warc::WarcHeader;
use warc::WarcReader;
use std::time::Instant;

fn main() -> Result<(), std::io::Error> {
    let file = WarcReader::from_path_gzip("webcrawl-1.warc.gzip")?;

    let mut count = 0;
    let start_time = Instant::now();
    for record in file.iter_records() {
        count += 1;
        match record {
            Err(err) => println!("ERROR: {}\r\n", err),
            Ok(record) => {
                // println!("{}", count);
                // println!("{}: {}", WarcHeader::RecordID.to_string(), record.warc_id());
                // println!("{}: {}", WarcHeader::Date.to_string(), record.date());
                // println!("");
                if count == 10000 {break}
            }
        }
    }
    let end_time = Instant::now();
    println!("Total records: {}, read in: {:?}", count, end_time.duration_since(start_time));

    Ok(())
}
