use warc::WarcHeader;
use warc::WarcReader;
use std::collections::HashMap;
use std::time::Instant;

fn main() -> Result<(), std::io::Error> {

    //TODO: Make this map as a constant; look for initialization with values
    let mut CDX_FIELDS: HashMap<&str, &str> = HashMap::new();
    CDX_FIELDS.insert("N", "massaged_url");
    CDX_FIELDS.insert("b", "date");
    CDX_FIELDS.insert("a", "original_url");
    CDX_FIELDS.insert("m", "mime_type");
    CDX_FIELDS.insert("s", "response_code");
    CDX_FIELDS.insert("k", "new_style_checksum");
    CDX_FIELDS.insert("r", "redirect");
    CDX_FIELDS.insert("M", "meta_tags");
    CDX_FIELDS.insert("S", "compressed_record_size");
    CDX_FIELDS.insert("V", "compressed_arc_file_offset");
    CDX_FIELDS.insert("g", "file_name");


    let file = WarcReader::from_path_gzip("webcrawl-1.warc.gzip")?;

    let mut count = 0;
    let start_time = Instant::now();

    let mut record_offset = 0;
    for record in file.iter_records() {
        count += 1;
        match record {
            Err(err) => println!("ERROR: {}\r\n", err),
            Ok(record) => {
                // println!("{}: {}", WarcHeader::RecordID.to_string(), record.warc_id());
                // println!("{}: {}", WarcHeader::Date.to_string(), record.date());
                // println!("{}: {}", WarcHeader::TargetURI.to_string(), record.header(WarcHeader::TargetURI));
                // println!("{}: {}", "warc-record-offset", record_offset);
                // println!("{}: {}", "warc-record-body", String::from_utf8_lossy(record.body()));
                // println!("");
                record_offset += record.content_length();
                // if count%3 == 0 {println!("{}: {}", "warc-record-offset", record_offset);}
                if count == 50000 {break}
            }
        }
    }
    let end_time = Instant::now();
    println!("Total records: {}, read in: {:?}", count, end_time.duration_since(start_time));

    Ok(())
}
